#ifndef __DECRYPTION_HPP
#define __DECRYPTION_HPP

#include <unordered_map>

#include "Bipoint.hpp"
#include "Quadripoint.hpp"
#include "PrivateKey.hpp"
#include "pairing.hpp"

int decrypt(const Bipoint<curvepoint_fp_t>& ciphertext, const PrivateKey& private_key);
int decrypt(const Bipoint<twistpoint_fp2_t>& ciphertext, const PrivateKey& private_key);
int decrypt(const Quadripoint& ciphertext, const PrivateKey& private_key);

#endif /* __DECRYPTION_HPP */
